<?
/*
	typedef struct pcap_hdr_s { 
		guint32 magic_number;   // magic number: 0xa1b2c3d4 (identical) or 0xd4c3b2a1 (swapped)
		guint16 version_major;  // major version number: 2 
		guint16 version_minor;  // minor version number: 4 
		gint32  thiszone;       // GMT to local correction: 0 
		guint32 sigfigs;        // accuracy of timestamps: 0 
		guint32 snaplen;        // max length of captured packets, in octets: 65535
		guint32 network;        // data link type: 1 for Ethernet 
	} pcap_hdr_t;
	24 bytes

	typedef struct pcaprec_hdr_s { 
		guint32 ts_sec;         // timestamp seconds 
		guint32 ts_usec;        // timestamp microseconds 
		guint32 incl_len;       // number of octets of packet saved in file 
		guint32 orig_len;       // actual length of packet 
	} pcaprec_hdr_t;
	16 bytes

	Reference: http://wiki.ethereal.com/Development/LibpcapFileFormat

	typedef struct ethernet {
		u_char  ether_dhost[ETHER_ADDR_LEN];    // destination host address 
		u_char  ether_shost[ETHER_ADDR_LEN];    // source host address 
		u_short ether_type;                     // IP? ARP? RARP? etc 
	};
	14 bytes

	0 1 2 3 4 5 6 7 0 1 2 3 4 5 6 7 0 1 2 3 4 5 6 7 0 1 2 3 4 5 6 7
	+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
	|Version| HLEN  |Type of Service|          Total Length       |
	+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
	|         Identification        |Flags|      Fragment Offset  |
	+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
	|  Time to Live |    Protocol   |         Header Checksum     |
	+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
	|                       Source Address                        |
	+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
	|                    Destination Address                      |
	+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

	typedef struct ip {
		u_char  ip_vhl;                 // version << 4 | header length >> 2 
		u_char  ip_tos;                 // type of service 
		u_short ip_len;                 // total length 
		u_short ip_id;                  // identification 
		u_short ip_off;                 // fragment offset field 
		#define IP_RF 0x8000            // reserved fragment flag 
		#define IP_DF 0x4000            // dont fragment flag 
		#define IP_MF 0x2000            // more fragments flag 
		#define IP_OFFMASK 0x1fff       // mask for fragmenting bits 
		u_char  ip_ttl;                 // time to live 
		u_char  ip_p;                   // protocol 
		u_short ip_sum;                 // checksum 
		struct  in_addr ip_src,ip_dst;  // source and dest address 
	};
	20 bytes

	0 1 2 3 4 5 6 7 0 1 2 3 4 5 6 7 0 1 2 3 4 5 6 7 0 1 2 3 4 5 6 7
	+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
	|          Source Port          |       Destination Port      |
	+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
	|          Total Length         |           Checksum          |
	+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

	typedef struct udp {
		u_short uh_sport;               // source port 
		u_short uh_dport;               // destination port 
		u_short uh_ulen;                // udp length 
		u_short uh_sum;                 // udp checksum 
	};
	8 bytes

*/
	require_once('init.php');
	require_once('codehex.php');
	//$file = "/home/sepp/www/makepcap/test.pcap";

	//$ts = "[20061123140826971481]";
	//$ts = "[20061123133004415289,20061123140826971481]";
	//make_pcap($ts, $file);

	function make_pcap($ts_array, $file) {
		global $filter;
		//$ts = "20061123140826971481";
		$ts_array = substr($ts_array, 1, strpos($ts_array, "]")-1);
		$ts_arr = explode(",", $ts_array);

		$handle_w = fopen($file, "wb") or die("Failed!");

		$pcap_hdr_s = "\xd4\xc3\xb2\xa1";	//0xd4c3b2a1 (swapped)
		$pcap_hdr_s .= "\x02\x00\x04\x00";	//2.4
		$pcap_hdr_s .= "\x00\x00\x00\x00";	//0
		$pcap_hdr_s .= "\x00\x00\x00\x00";	//0
		$pcap_hdr_s .= "\xff\xff\x00\x00";	//65535
		$pcap_hdr_s .= "\x01\x00\x00\x00";	//1

		for ($i=0; $i<count($ts_arr); $i++) {
			$r = mysql_query("SELECT `ipsrc`, `ipdst`, `original` FROM `sipmsg` WHERE `ts` = '".$ts_arr[$i]."' ORDER BY `ts` ASC");
			while($row = mysql_fetch_array($r))	{
				list($ip_src1, $ip_src2, $ip_src3, $ip_src4) = explode(".", $row['ipsrc']);
				list($ip_dst1, $ip_dst2, $ip_dst3, $ip_dst4) = explode(".", $row['ipdst']);
				$msg = $row['original'];
				//$message .= str_replace("<br>", "\n", strtr($row['original'], $filter))."\n";
			}
//		$message .= $ts_arr[$i]." ";
//		}

/*
		$r = mysql_query("SELECT * FROM `sipmsg` WHERE `ts` = '".$ts."' ORDER BY `ts` ASC");
		while($row = mysql_fetch_array($r)) {
			list($ip_src1, $ip_src2, $ip_src3, $ip_src4) = explode(".", $row['ipsrc']);
			list($ip_dst1, $ip_dst2, $ip_dst3, $ip_dst4) = explode(".", $row['ipdst']);
			$msg = $row['original'];
		}
*/

		//$file = "/home/sepp/www/makepcap/test.pcap";
/*		
			$handle_w = fopen($file, "wb") or die("Failed!");

			$pcap_hdr_s = "\xd4\xc3\xb2\xa1";	//0xd4c3b2a1 (swapped)
			$pcap_hdr_s .= "\x02\x00\x04\x00";	//2.4
			$pcap_hdr_s .= "\x00\x00\x00\x00";	//0
			$pcap_hdr_s .= "\x00\x00\x00\x00";	//0
			$pcap_hdr_s .= "\xff\xff\x00\x00";	//65535
			$pcap_hdr_s .= "\x01\x00\x00\x00";	//1
*/
			//$pcap_hdr_s = "\xa1\xb2\xc3\xd4\x00\x02\x00\x04\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xff\x00\x00\x00\x01";

			//$ts = strtotime("2006/11/23 13:30:04");
			//$ts_u = "415289";

			$ts_sec = dechex(strtotime(substr($ts_arr[$i], 0, 14)));					//timestamp
			$ts_sec1 = substr($ts_sec, 0, 2);
			$ts_sec2 = substr($ts_sec, 2, 2);
			$ts_sec3 = substr($ts_sec, 4, 2);
			$ts_sec4 = substr($ts_sec, 6, 2);

			$ts_usec = sprintf("%06s", dechex(substr($ts_arr[$i], 14, 6)));
			$ts_usec1 = substr($ts_usec, 0, 2);
			$ts_usec2 = substr($ts_usec, 2, 2);
			$ts_usec3 = substr($ts_usec, 4, 2);

		/*
			$temp = sprintf("%s%s%s%s\x75\x34\x89\x22\x00\x00\x00\x01\x00\x00\x00\x01", 
					chr(hexdec($ts_sec1)), chr(hexdec($ts_sec2)), chr(hexdec($ts_sec3)), chr(hexdec($ts_sec4)));

			echo "DEBUG - " . $temp . "\n";
			echo "<BR>DEBUG - " . $ts_sec2 . "=>" . chr(hexdec($ts_sec2)) . "\n";

			$filter = array("dc" => "\xdc", "31" => "\x31");
		*/
			//echo "&#20013;&#25991;<br>";
			$sip = strtr($msg, $filter);
			//echo strtr($msg, $filter);
			if (!strstr($sip, "\x0d\x0a\x0d\x0a")) $sip .= "\x0d\x0a";

			$udp_len1 = substr(sprintf("%04s", dechex(strlen($sip)+8)), 0, 2);
			$udp_len2 = substr(sprintf("%04s", dechex(strlen($sip)+8)), 2, 2);

			$udp = sprintf("\x13\xc4\x13\xc4%c%c\x00\x00", hexdec($udp_len1), hexdec($udp_len2));	//src&dst port:5060 length checksum

			$ip_len1 = substr(sprintf("%04s", dechex(strlen($sip)+28)), 0, 2);
			$ip_len2 = substr(sprintf("%04s", dechex(strlen($sip)+28)), 2, 2);
			
			$id = sprintf("%04s", dechex($i+1));
			$id1 = substr($id, 0, 2);
			$id2 = substr($id, 2, 2);

			$partial_sum = sprintf("%08s", dechex(0x4500 + hexdec(sprintf("%02s%02s", $ip_len1, $ip_len2)) + hexdec(sprintf("%02s%02s", $id1, $id2)) + 0x5011 + hexdec(sprintf("%02s%02s", dechex($ip_src1), dechex($ip_src2))) + hexdec(sprintf("%02s%02s", dechex($ip_src3), dechex($ip_src4))) + hexdec(sprintf("%02s%02s", dechex($ip_dst1), dechex($ip_dst2))) + hexdec(sprintf("%02s%02s", dechex($ip_dst3), dechex($ip_dst4)))));

			$last_carry = substr($partial_sum, -5, 1);
			
			$checksum = sprintf("%x", ~(hexdec($partial_sum)+$last_carry));

			//echo "<br>".$checksum;
			$checksum1 = substr($checksum, -4, 2);
			$checksum2 = substr($checksum, -2, 2);

			$ip = sprintf("\x45\x00%c%c", hexdec($ip_len1), hexdec($ip_len2));	//ver:4 hlen:5 ds:normal length
			$ip .= sprintf("%c%c\x00\x00\x50\x11%c%c", hexdec($id1), hexdec($id2), hexdec($checksum1), hexdec($checksum2));		//id flag&offset:0 ttl:80 protocol:udp checksum
			//$ip .= "\xa3\x16\x10\x20\x0a\x0a\x10\x17";									//ipsrc ipdst
			$ip .= sprintf("%c%c%c%c%c%c%c%c", $ip_src1, $ip_src2, $ip_src3, $ip_src4, $ip_dst1, $ip_dst2, $ip_dst3, $ip_dst4);									//ipsrc ipdst

			$eth = "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00";	//mac address
			$eth .= "\x08\x00";														//type: IP

			$packet_data = $eth . $ip . $udp . $sip;
			$packet_size = sprintf("%04s", dechex(strlen($packet_data)));
			$packet_size1 = substr($packet_size, 0, 2);
			$packet_size2 = substr($packet_size, 2, 2);

			//$pcaprec_hdr_s = "\xdc\x31\x65\x45\x75\x34\x89\x22\x01\x00\x00\x00\x01\x00\x00\x00";
			$pcaprec_hdr_s = sprintf("%c%c%c%c%c%c%c\x00%c%c\x00\x00%c%c\x00\x00", hexdec($ts_sec4), hexdec($ts_sec3), hexdec($ts_sec2), hexdec($ts_sec1), hexdec($ts_usec3), hexdec($ts_usec2), hexdec($ts_usec1), hexdec($packet_size2), hexdec($packet_size1), hexdec($packet_size2), hexdec($packet_size1));

			
			if ($i==0) {
				$data_w = $pcap_hdr_s . $pcaprec_hdr_s . $packet_data;
			} else if ($i>0) {
				$data_w .= $pcaprec_hdr_s . $packet_data;
			}

		}//loop end: ts_arr is empty

		//$packet_data = "\x01";

		//$data_w = $pcap_hdr_s . $pcaprec_hdr_s . $packet_data;

		$size = fprintf($handle_w, "%s", $data_w);

		fclose($handle_w);
	
		//echo "<br>SIP=>".strlen($sip)."bytes PCAP=>".$size." bytes<br>";

		//echo $size." bytes<br>";

		return $i;

	}

/*	
	$handle_r = fopen($file, "r") or die("Failed!");

	while(!feof($handle_r)) {

		$data_r .= fgets($handle_r);
	
	}

	echo $data_r;

	fclose($handle_r);
*/
?>
